#include "myIncludes.h"
#include "myProtos.h"
#include "sound.h"
#include "StdDef.h"


typedef SndCommand	*SndCmdsPtr;

extern	Boolean		gQuit;
extern	AEDesc		gTheAddress;

extern	void	zero_mem(register char*, register short);
		void	updateAEAddress(AppleEvent *aep);


pascal OSErr AEOpenHandler(AppleEvent *messagein, AppleEvent *reply, long refIn)
{
#pragma unused (messagein,reply,refIn)
    return(noErr);
}


pascal OSErr AEOpenDocHandler(AppleEvent *messagein, AppleEvent *reply, long refIn)
{
#pragma unused (messagein,reply, refIn)
    return(errAEEventNotHandled);
}



pascal OSErr AEPrintHandler(AppleEvent *messagein, AppleEvent *reply, long refIn)
{
#pragma unused (messagein,reply,refIn)    /* we don't support printing */
    return(errAEEventNotHandled);
}


pascal OSErr AEQuitHandler(AppleEvent *messagein, AppleEvent *reply, long refIn)
{
#pragma unused (messagein, reply,refIn)
    gQuit = true;
    return(noErr);
}


pascal OSErr do_step1(AppleEvent *messagein, AppleEvent *reply, long refIn)
{
#pragma unused (messagein,refIn)

OSErr	err;
long	ticks;

	if (reply == NULL)
		return(-1);
	
	ticks = TickCount();
	err = AEPutParamPtr(reply, TICKS_PARAM, typeLongInteger, (Ptr)&ticks, 4);
	
    return(err);
}


OSErr SetWaveTable(SndChannelPtr chan, Byte *name);
OSErr SetWaveTable(SndChannelPtr chan, Byte *name)
{
	SndCommand	cmd;
	Byte		*waveTable;
	Byte		*p;
	short		i;
	OSErr		result;
	Handle		h;
	
	if ((h=GetNamedResource('snd ', name)))
	{
		HLock(h);
		waveTable = ((Byte*)*h) + 20;
		cmd.param1 = ((short*)*h)[7];
	}
	else
	{
		waveTable = (Byte*)NewPtr(512);
		if (waveTable == nil)
			return (MemError());
		
		p = waveTable;
		for (i = (512 / 2) - 1; i >= 0; --i)
			*p++ = 0xFF;
		for (i = (512 / 2) - 1; i >= 0; --i)
			*p++ = 0x00;
			
		cmd.param1 = 800;
	}
	cmd.cmd = waveTableCmd;
	cmd.param2 = (long)waveTable;
	result = SndDoImmediate(chan, &cmd);
	
	if (h)
		ReleaseResource(h);
	else
		DisposePtr(waveTable);
	return (result);
}

void play_music(SndCmdsPtr trebleCmdPtr, long trebNumNotes, SndCmdsPtr bassCmdPtr, long bassNumNotes);
void play_music(SndCmdsPtr trebleCmdPtr, long trebNumNotes, SndCmdsPtr bassCmdPtr, long bassNumNotes)
{
long			i;
OSErr			err;
SndChannelPtr	trebscp, bassscp;
SndCmdsPtr		curTrebleCmdPtr, curBassCmdPtr;
SndCommand		snd;
long			howManyCmds;


	if (trebNumNotes < stdQLength)
		howManyCmds = stdQLength + 1;
	else
		howManyCmds = trebNumNotes + 1;
		
	trebscp = (SndChannelPtr)NewPtrClear( offsetof(SndChannel,queue) + (howManyCmds*sizeof(SndCommand)) );
	if ( trebscp == NULL )
		goto Failure;
	trebscp->qLength = howManyCmds;	/* notes plus pauses between notes */

	if (bassNumNotes < stdQLength)
		howManyCmds = stdQLength + 1;
	else
		howManyCmds = bassNumNotes + 1;
		
	bassscp = (SndChannelPtr)NewPtrClear( offsetof(SndChannel,queue) + (howManyCmds*sizeof(SndCommand)) );
	if (bassscp == NULL)
		goto Failure;
	bassscp->qLength = howManyCmds;	/* notes plus pauses between notes */

	err = SndNewChannel(&trebscp, waveTableSynth, initChan0, NULL);
	if (err)
		goto Failure;
	err = SndNewChannel(&bassscp, waveTableSynth, initChan1, NULL);
	if (err)
		goto ChanFailure1;
	
	SetWaveTable(trebscp, "\pAlto");
	SetWaveTable(bassscp, "\pTenor");
	
	snd.cmd = pauseCmd;
	snd.param1 = snd.param2 = 0;
	err = SndDoImmediate(trebscp, &snd);
	if (err)
		goto ChanFailure2;
	
	snd.cmd = pauseCmd;
	snd.param1 = snd.param2 = 0;
	err = SndDoImmediate(bassscp, &snd);
	if (err)
		goto ChanFailure2;
	
	snd.cmd = syncCmd;
	snd.param1 = 2;
	snd.param2 = 'KATH';
	err = SndDoCommand(trebscp, &snd, FALSE);
	if (err)
		goto ChanFailure2;
		
	snd.param1 = 1;
	err = SndDoCommand(bassscp, &snd, FALSE);
	if (err)
		goto ChanFailure2;
	
	curTrebleCmdPtr = trebleCmdPtr;
	for (i = 0; i < trebNumNotes; i++)
		{
		err = SndDoCommand(trebscp, curTrebleCmdPtr++, FALSE);
		if (err)
			goto ChanFailure2;
		}
		
	curBassCmdPtr = bassCmdPtr;
	for (i = 0; i < bassNumNotes; i++)
		{
		err = SndDoCommand(bassscp, curBassCmdPtr++, FALSE);
		if (err)
			goto ChanFailure2;
		}
	
	snd.cmd = resumeCmd;
	snd.param1 = snd.param2 = 0;
	err = SndDoImmediate(trebscp, &snd);
		if (err)
			goto ChanFailure2;
	err = SndDoImmediate(bassscp, &snd);
		if (err)
			goto ChanFailure2;
	err = SndDisposeChannel(bassscp, false);
	err = SndDisposeChannel(trebscp, false);
	return;

// handle any errors
ChanFailure2:
	err = SndDisposeChannel(bassscp, true);
ChanFailure1:
	err = SndDisposeChannel(trebscp, true);
Failure:
	return;
}


pascal OSErr do_step2(AppleEvent *messagein, AppleEvent *reply, long refIn)
{
#pragma unused (reply,refIn)
Size		bassSize, trebSize, actualSize;
DescType	actualType;
Ptr			datap1, datap2;
OSErr		err;
long		bassNumNotes, trebNumNotes, startTime, delayTime;

	if (err = AESizeOfParam(messagein, MUSIC_TREBLE, &actualType, &trebSize))
		return(err);
	
	trebNumNotes = trebSize / sizeof(SndCommand);
	datap1 = NewPtrClear(trebSize);

	if (err = AESizeOfParam(messagein, MUSIC_BASS, &actualType, &bassSize))
		return(err);
	
	bassNumNotes = bassSize / sizeof(SndCommand);
	datap2 = NewPtrClear(bassSize);

	if ( (datap1 == NULL) || (datap2 == NULL) )
		return(err?err:-1);
	
	err = AEGetParamPtr(messagein, MUSIC_TREBLE, TREBLE_VOICE, &actualType, 
			datap1, trebSize, &actualSize);
	
	if (err == noErr)
		{
		err = AEGetParamPtr(messagein, MUSIC_BASS, BASS_VOICE, &actualType, 
				datap2, bassSize, &actualSize);
		}
	
	if (err == noErr)
		{
		err = AEGetParamPtr(messagein, TICKS_PARAM, typeLongInteger, &actualType, 
				(Ptr)&startTime, 4, &actualSize);
		}
	
	if (err)
		{
		SysBeep(0);	SysBeep(0);	SysBeep(0);
		}
	else
		{
		delayTime = startTime - TickCount();
		if (delayTime > 0)
			Delay(delayTime, &startTime);
		play_music((SndCmdsPtr)datap1, trebNumNotes, (SndCmdsPtr)datap2, bassNumNotes);
		}
	
	DisposePtr(datap1);
	DisposePtr(datap2);
	return(noErr);
}


void
updateAEAddress(AppleEvent *messagein)
{
	AEDisposeDesc(&gTheAddress);
	AEGetAttributeDesc(messagein, keyAddressAttr, typeTargetID, &gTheAddress);
}

