#ifndef __SONICALARMMISC__
#define __SONICALARMMISC__
#endif

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// public routines 

Boolean			HasSoundInput(void);
OSErr			InitSndTools(void);
void			CloseSndTools(void);
void			CloseSndDevice(void);
OSErr			GetBufferOffset(Handle sndHandle, long *offset);
Boolean			IsPlayingSound(void);
OSErr			PlaySound(short resID);
void			StopPlaying(void);
OSErr			InitSndChan(void);
void			CloseSndChan(void);
short			GetCurLevel(void);

void			DrawCountDown(WindowPtr window, Point location, long *lastTickCount, short *secondsCountDown);
void			DrawPassword(Rect drawArea, short length);
Boolean			IsVolumeTooLoud(void);
short			GetAverageLevel(void);
void			UpdateAverageLevel(void);
void			SetSensitivity(short percentage);
short			GetSensitivity(void);
long			GetSleep(void);
short			NumToolboxTraps(void);
Boolean			TrapExists(short theTrap);
Boolean			FailLowMemory(long memRequested);
void			AlertUser(short errNum, short errStrIndex, Boolean fatal);

OSErr			CreateLevelArray(void);
unsigned char	LimitStringLength(StringPtr pString, unsigned char max);
Boolean			IsDAWindow(WindowPtr window);
void			SelectButton(ControlHandle button);
void			*GetMyWindow(long windowSize, short windID);
long			GetMyWindowType(WindowPtr window);
Boolean			IsWindowModal(WindowPtr window);
void			*FindMyWindow(short windRefCon);
ControlHandle	GetMyControl(short cntlRefCon, WindowPtr window);
ControlHandle	FindMyControl(WindowPtr window, short cntlRefCon);
void			ActivateControls(WindowPtr window, Boolean becomingActive);

pascal void OutlineControl(short depth, short deviceFlags, GDHandle targetDevice, ControlHandle button);
GDHandle		GetRectDevice(Rect globalRect);

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// types

// A format 2 'snd ' resources.

typedef struct {
	short		format;
	short		refCount;
	short		numCmds;
	SndCommand	cmds[1];
} Snd2Header, *Snd2HdrPtr, **Snd2HdrHndl;


typedef SndCommand *SndCmdPtr;	// Ptr to a sound command, for type coersion

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// constants 

#define kCntlActivate		0			/* enabled controls hilite state */
#define kCntlDeactivate		0xFF		/* disabled controls hilite state */
#define kSelect				1			/* select the control */
#define kDeselect			0			/* deselect the control */
#define kCntlOn				1			/* controls value when truned on */
#define kCntlOff			0			/* controls value when truned off */

#define kButtonFrameInset		(-4)		/* inset rectangle adjustment around button */
#define kButtonFrameSize		3			/* button frames pen size */

// key from a key down event
#define charBackspace		'\b'		/* ASCII Backspace character */
#define charEnter			'\003'		/* ASCII Enter character */
#define charEscape			'\033'		/* ASCII Escape (aka Clear) key */
#define charHelp			'\005'		/* ASCII Help key */
#define charHome			'\001'		/* ASCII the Home key */
#define charLeft			'\034'		/* ASCII left arrow */
#define charPageDown		'\f'		/* ASCII Page Down key */
#define charPageUp			'\013'		/* ASCII Page Up key */
#define charReturn			'\r'		/* ASCII Return character */
#define charRight			'\035'		/* ASCII right arrow */
#define charSpace			' '			/* ASCII Space character */
#define charTab				'\t'		/* ASCII Tab character */
#define charUp				'\036'		/* ASCII up arrow */
#define charPeriod			'.'			/* ASCII period */

#define kMaxMeterLevel	255				// maximum meter level 

